# Core

Core types: `Knot`, `Assembler`, `Disassembler`, `Parameter`, `KnotConfig`, `ErrorPolicy`, `Result` (`Ok`, `Err`, `Skipped`), `RunRequest`, `RunResult`, `KnotLineage`.

---

## Knot

::: pirn.core.knot.Knot
    options:
      show_source: false
      members_order: source
      heading_level: 3

---

## `@knot` decorator

::: pirn.core.knot_factory.KnotFactory
    options:
      show_source: false
      heading_level: 3

---

## Optional mixin

::: pirn.core.optional.Optional
    options:
      show_source: false
      heading_level: 3

---

## Parameter

::: pirn.core.parameter.Parameter
    options:
      show_source: false
      members_order: source
      heading_level: 3

---

## KnotConfig

::: pirn.core.knot_config.KnotConfig
    options:
      show_source: false
      members_order: source
      heading_level: 3

---

## ErrorPolicy

::: pirn.core.error_policy.ErrorPolicy
    options:
      show_source: false
      heading_level: 3

---

## Result types

::: pirn.core.result.Ok
    options:
      show_source: false
      heading_level: 3

::: pirn.core.result.Err
    options:
      show_source: false
      heading_level: 3

::: pirn.core.result.Skipped
    options:
      show_source: false
      heading_level: 3

---

## RunRequest

::: pirn.core.run_request.RunRequest
    options:
      show_source: false
      members_order: source
      heading_level: 3

---

## RunResult

::: pirn.core.run_result.RunResult
    options:
      show_source: false
      members_order: source
      heading_level: 3

---

## KnotLineage

::: pirn.core.lineage.KnotLineage
    options:
      show_source: false
      members_order: source
      heading_level: 3

---

## Assembler

::: pirn.core.assembler.Assembler
    options:
      show_source: false
      members_order: source
      heading_level: 3

---

## Disassembler

::: pirn.core.disassembler.Disassembler
    options:
      show_source: false
      members_order: source
      heading_level: 3

---

## Content hashing

::: pirn.core.hashing.content_hash
    options:
      show_source: false
      heading_level: 3
